<template>
  <div class="col-md-10 pt-4">
    <my-vuetable :apiUrl="apiUrl" :fields="fields" :tableName="tableName" :perPage="perPage">
      <template slot="actions-slot" slot-scope="props">
        <transaction-detail-modal
          @show="selectData(props.rowData)"
          :transaction="selectedTransaction"
          :loading="modalLoading"
        ></transaction-detail-modal>
      </template>
      <template slot="header-slot">
        <div class="col-6 col-md-2">
          <transaction-filter-modal @applyFilter="applyFilter"></transaction-filter-modal>
          <!-- <div class="dropdown">
            <div class>
              <button data-toggle="dropdown" class="btn btn-primary capsule btn-block">Filter</button>

              <div class="dropdown-menu dropdown-menu-right" aria-labelledby="userDropdown">
                <div class="dropdown-header">
                  <i class="i-Lock-User mr-1"></i>
                  Filter
                </div>
                <datepicker></datepicker>
                <button class="btn btn-primary capsule btn-block">Apply</button>
              </div>
            </div>
          </div>-->
        </div>
      </template>
    </my-vuetable>
  </div>
</template>

<script>
import MyVuetable from "@/components/table/MyVuetable";
import FieldDefs from "./FieldDefs";
import SecondSideBar from "@/components/general/SecondSidebar";
import TransactionDetailModal from "./modals/TransactionDetailModal";
import TransactionFilterModal from "./modals/TransactionFilterModal";
import * as httpHelper from "@/helpers/httpHelper";
import Datepicker from "vuejs-datepicker";

export default {
  data() {
    return {
      fields: FieldDefs,
      tableName: "Transactions",
      selectedTransaction: null,
      perPage: 20,
      modalLoading: false
    };
  },
  computed: {
    apiUrl() {
      return (
        this.baseUrl + `/api/${this.$store.getters.appId.hashed}/transaction`
      );
    }
  },
  components: {
    MyVuetable,
    SecondSideBar,
    TransactionDetailModal,
    TransactionFilterModal,
    Datepicker
  },
  methods: {
    async selectData(data) {
      this.selectedTransaction = data;
      try {
        this.modalLoading = true;

        let response = await this.$axiosNoLoading.post(
          process.env.MIX_APP_URL +
            `/api/${this.$store.getters.appId.hashed}/transaction/get-detail`,
          { transactionNo: data.hashedTransactionNo }
        );
        this.selectedTransaction = {
          ...this.selectedTransaction,
          detail: response.data.data.transactionDetail
        };
      } catch (error) {
        httpHelper.errorToast(this, error);
      }
      this.modalLoading = false;
    },

    deleteTransaction() {
      console.log(this.selectedTransaction);
    },
    applyFilter(filterData) {
      console.log(filterData);
    }
  }
};
</script>
